<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Adressbook
 * @package    QuickTeam
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2007-2010 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.8 build:20080620
 * @link       http://www.qt-cute/doc/package/qte
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qte_init.php');

include(Translate($_SESSION[QT]['language'],'qte_lang_adm.inc'));
include(Translate($_SESSION[QT]['language'],'qtem_export.inc'));

if ( $oVIP->role!='A' ) die($L['R_admin']);

// INITIALISE

if ( !isset($_SESSION['m_export']) )
{ 
  $_SESSION['m_export'] = array(
  'title'     => 'export_'.date('Ymd').'.txt',
  'format'    => 'CSV',
  'delimit'   => ';',
  'enclose'   => '"',
  'null'      => 'NULL',
  'firstline' => 'Y');
}

$oVIP->selfurl = 'qtem_export_adm.php';
$oVIP->selfname = $L['export']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['export']['Version'].' 1.8<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  
  // ------------
  // READ AND CHECK MANDATORY PARAMETERS
  // ------------
  
  $_SESSION['m_export']['format']  = trim($_POST['format']);
  $_SESSION['m_export']['delimit'] = trim($_POST['delimiter']);
  $_SESSION['m_export']['enclose'] = $_POST['enclose'];  if ( get_magic_quotes_gpc() ) $_SESSION['m_export']['enclose'] = stripslashes($_POST['enclose']);
  $_SESSION['m_export']['null']    = trim($_POST['null']);
  if ( isset($_POST['firstline']) ) $_SESSION['m_export']['firstline']='Y';
  if ( empty($_SESSION['m_export']['delimit']) ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];  
  if ( empty($qte_error) )
  {
    if ( strlen($_SESSION['m_export']['delimit'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['delimit']) ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    if ( $_SESSION['m_export']['delimit']=='.' ) $qte_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($_SESSION['m_export']['enclose'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['enclose']) ) $qte_error=$L['export']['Encloser'].S.$L['E_invalid'];
    if ( $_SESSION['m_export']['enclose']=='.' ) $qte_error=$L['export']['Encloser'].S.$L['E_invalid'];
    }
    if ( $_SESSION['m_export']['format']=='SQL' ) $_SESSION['m_export']['delimit'] = ',';
  }

  // ------------
  // EXPORT COUNT
  // ------------
  
  if ( empty($qte_error) )
  {
    // query
    $strQ = 'SELECT count(*) as countid FROM '.TABUSER;
    if ( $_POST['section']!='*' ) $strQ = 'SELECT count(u.id) as countid FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$_POST['section'];
    
    // count
    $oDB->Query($strQ);
    $row=$oDB->Getrow();
    if ( $row['countid']==0 ) $qte_error='No data found';
  }

  // ------------
  // EXPORT START
  // ------------

  if ( empty($qte_error) )
  {
    $strDouble = '"';
    $strSingle = "'";
    $strQ = 'SELECT id,username,pwd,role,type,status,children,title,firstname,midname,lastname,alias,birthdate,nationality,sexe,picture,address,phones,emails,www,privacy,signature,descr,firstdate,teamid1,teamid2,teamrole1,teamrole2,teamdate1,teamdate2,teamvalue1,teamvalue2,teamflag1,teamflag2,x,y,z,ip FROM '.TABUSER;
    if ( $_POST['section']!='*' ) $strQ = 'SELECT u.id, u.username, u.pwd, u.role, u.type, u.status, u.children, u.title, u.firstname, u.midname, u.lastname, u.alias, u.birthdate, u.nationality, u.sexe, u.picture, u.address, u.phones, u.emails, u.www, u.privacy, u.signature, u.descr, u.firstdate, u.teamid1, u.teamid2, u.teamrole1, u.teamrole2, u.teamdate1, u.teamdate2, u.teamvalue1, u.teamvalue2, u.teamflag1, u.teamflag2, u.x, u.y, u.z, u.ip FROM '.TABUSER.' u INNER JOIN '.TABS2U.' l ON l.userid=u.id WHERE l.sid='.$_POST['section'];

    if ( !headers_sent() )
    {
      header('Content-Type: text/plain; charset='.QTE_HTML_CHAR);
      header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'"');
    }

    if ( $_SESSION['m_export']['firstline']=='Y' )
    {
      $strLine = '';
      foreach (array('id','username','pwd','role','type','status','children','title','firstname','midname','lastname','alias','birthdate','nationality','sexe','picture','address','phones','emails','www','privacy','signature','descr','firstdate','teamid1','teamid2','teamrole1','teamrole2','teamdate1','teamdate2','teamvalue1','teamvalue2','teamflag1','teamflag2','x','y','z','ip') as $oValue)
      {
      $strLine .= ( empty($strLine) ?  '' : $_SESSION['m_export']['delimit'] ).$_SESSION['m_export']['enclose'].$oValue.$_SESSION['m_export']['enclose'];
      }
      $strLine = ($_SESSION['m_export']['format']=='SQL' ? '# ' : '').$strLine."\r\n";
      echo $strLine;
    }

    $oDB->Query($strQ);
    While( $row=$oDB->Getrow() )
    {
      $strLine = '';
      foreach ( $row as $strKey => $oValue )
      {
        $bEnclose = true;
        $bProcess = true;
        if ( $strLine!='' ) $strLine .= $_SESSION['m_export']['delimit'];

        if ( is_null($oValue) )
        {
          $strLine .= $_SESSION['m_export']['null'];
        }
        else
        {
          if ( in_array($strKey,array('id','x','y','z','teamvalue1','teamvalue2')) ) { $bEnclose = false; $bProcess = false; }
          if ( in_array($strKey,array('pwd','role','type','status','children','birthdate','firstdate','teamdate1','teamdate2','ip')) )  $bProcess = false;
          // text pre-process
          if ( $bProcess )
          {
            if ( $_SESSION['m_export']['enclose']=='"' )
            {
            $strDouble="'";
            }
            elseif ( $_SESSION['m_export']['enclose']=="'" )
            {
            $strSingle="";
            }
            else
            {
            $oValue = str_replace($_SESSION['m_export']['enclose'],"'",$oValue);
            }
            $oValue = QThtml2text($oValue,$strDouble,$strSingle);
            if ( $_SESSION['m_export']['delimit']==';' )
            {
            $oValue = str_replace($_SESSION['m_export']['delimit'],',',$oValue);
            }
            elseif ( $_SESSION['m_export']['delimit']==',' )
            {
            $oValue = str_replace($_SESSION['m_export']['delimit'],';',$oValue);
            }
            else
            {
            $oValue = str_replace($_SESSION['m_export']['delimit'],',',$oValue);
            }
          }
          // text enclose
          if ( $bEnclose )
          {
            $oValue = $_SESSION['m_export']['enclose'].$oValue.$_SESSION['m_export']['enclose'];
          }
          $strLine .= $oValue;
        }
      }

      // output

      if ( $_SESSION['m_export']['format']=='CSV' )
      {
        $strLine .= "\r\n";
      }
      else
      {
        $strLine = 'INSERT INTO '.TABUSER.' (id,username,pwd,role,type,status,children,title,firstname,midname,lastname,alias,birthdate,nationality,sexe,picture,address,phones,emails,www,privacy,signature,descr,firstdate,teamid1,teamid2,teamrole1,teamrole2,teamdate1,teamdate2,teamvalue1,teamvalue2,teamflag1,teamflag2,x,y,z,ip) VALUES ('.$strLine.')'."\r\n";
      }
      echo $strLine;
    }
    exit;
  }
}

// --------
// HTML START
// --------

include('qte_adm_p_header.php');
include('qte_adm_p_title.php');

// FORM

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(html_entity_decode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="tab" cellspacing="0">
<tr class="tr">
<th class="th_o th_o_all" colspan="3">',$L['Adm_settings'],'</th>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first" style="width:200px"><label for="format">',$L['export']['Format'],'</label></th>
<td class="td_o"><select id="format" name="format">
<option value="CSV"',($_SESSION['m_export']['format']=='CSV' ? QSEL : ''),'>',$L['export']['Csv'],'</option>
<option value="SQL"',($_SESSION['m_export']['format']=='SQL' ? QSEL : ''),'>',$L['export']['Sql'],'</option>
</select></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="delimiter">',$L['export']['Delimiter'],'</label></th>
<td class="td_o"><input type="text" id="delimiter" name="delimiter" size="1" maxlength="2" value="',$_SESSION['m_export']['delimit'],'"/></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="enclose">',$L['export']['Encloser'],'</label></th>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="2" value="',htmlspecialchars($_SESSION['m_export']['enclose']),'"/></td>
<td class="td_o"><span class="help">',$L['export']['H_Encloser'],'</span></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="null">',$L['export']['Replace_null'],'</label></th>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$_SESSION['m_export']['null'],'"/></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first">',$L['export']['First_line'],'</th>
<td class="td_o" colspan="2"><input type="checkbox" id="firstline" name="firstline"',($_SESSION['m_export']['firstline']=='Y' ? QCHE : ''),'/><label for="firstline">',$L['export']['H_First_line'],'</label></td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="3">',$L['export']['Content'],'</th>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_first"><label for="section">',$L['Section'],'</label></th>
<td class="td_o" colspan="2">
<select id="section" name="section" size="1">
<option value="*">&lt; ',$L['All'],' &gt;</option>',QTastags(GetSectionTitles($oDB,'A')),'</select>
</td>
</tr>
';
echo '<tr class="tr">
<th class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></th>
</tr>
';
echo '</table>';
echo '</form>';

// HTML END

include('qte_adm_p_footer.php');

?>